
%global meadversion 1.0.1
%global namedversion 1.0.1.Final-redhat-2
%global meadalpha .Final_redhat_2
%global meadrel .2
%global serial 9

# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_with javadoc
%bcond_without mead

%if "%{?rhel}" == "6"
%bcond_without repolib
%else
%bcond_with repolib
%endif

%global alternativespriority 010100
%global apiname jaxrs
%global apiversion 1.1
%global apiversionu 1_1
%global apigroupid javax.ws.rs
%global apiartifactid jsr311-api

%define maven_version 1.0.1.Final-redhat-2

Name:           jboss-%{apiname}-api_%{apiversion}_spec
Version:        %{meadversion}
Release:        %{serial}%{meadalpha}%{meadrel}%{?dist}
Epoch:          0
Summary:        The Java(TM) API for RESTful Web Services (JAX-RS) %{apiversion}
License:        LGPLv2+
URL:            http://fisheye.jboss.org/browse/JBossAS/projects/specs/tags/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}
Group:          Development/Java

%if %with mead
Source100: org.jboss.spec.javax.ws.rs-jboss-jaxrs-api_1.1_spec-1.0.1.Final-redhat-2-sources.zip
Source101: org.jboss.spec.javax.ws.rs-jboss-jaxrs-api_1.1_spec-1.0.1.Final-redhat-2-patches.zip
Source102: jboss-jaxrs-api_1.1_spec-1.0.1.Final-redhat-2.pom
Source103: jboss-jaxrs-api_1.1_spec-1.0.1.Final-redhat-2-javadoc.jar
Source104: jboss-jaxrs-api_1.1_spec-1.0.1.Final-redhat-2-sources.jar
Source105: jboss-jaxrs-api_1.1_spec-1.0.1.Final-redhat-2.jar
%endif

%if %without mead
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/specs/tags/jboss-jaxrs-api_1.1_spec-1.0.0.Final && tar cjf jboss-jaxrs-api_1.1_spec-1.0.0.Final.tar.bz2 jboss-jaxrs-api_1.1_spec-1.0.0.Final
# Exported revision 110833.
#Source0:        jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.tar.bz2
#Source3:        jaxrs-api-1.1.pom
#Patch0:         jboss-%{apiname}-api_%{apiversion}_spec-pom.patch
%endif
Provides:       %{apiname}_%{apiversionu}_api
Provides:       %{apiname}_api = 0:%{apiversion}
Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
# Removed to avoid conflict on RHEL-7
#Requires:       jboss-specs-parent >= 1.0.0-0.1.Beta2
%if %with mead
BuildRequires:  unzip
%else
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-skins
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-surefire-report-plugin
BuildRequires:  mojo-maven2-plugin-taglist
BuildRequires:  jboss-parent
BuildRequires:  jboss-specs-parent >= 1.0.0-0.1.Beta2
BuildRequires:  jbossweb-servlet-2.5-api
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JSR 311: The Java(TM) API for RESTful Web Services (JAX-RS) %{apiversion}.

%if %with javadoc
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description javadoc
%{summary}.
%endif

%if %without mead
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
Requires:       %{name}-javadoc = %{epoch}:%{version}-%{release}

%description manual
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif
%endif

%prep
%if %without mead
%setup -q -n jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}
%patch0 -p1 -b .sav0
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp \
        -e \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -DaltDeploymentRepository=remote-repository::default::file://`pwd`/maven2-brew \
        javadoc:javadoc javadoc:jar source:jar deploy site
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
pushd maven2-brew
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.jar %{buildroot}%{_javadir}/
%if 0
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/
%endif
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-sources.jar %{buildroot}%{_javadir}/
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%if 0
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-javadoc.jar
%endif
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%endif
(cd %{buildroot}%{_javadir}/ && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# jar alternatives
/bin/touch %{buildroot}%{_javadir}/%{apiname}_api.jar
/bin/touch %{buildroot}%{_javadir}/%{apiname}_%{apiversionu}_api.jar

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%if %without mead
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom
%endif

# pom alternatives
%if %without mead
/bin/touch %{buildroot}%{_datadir}/maven2/poms/JPP-%{apiname}_%{apiversionu}_api.pom
/bin/touch %{buildroot}%{_datadir}/maven2/poms/JPP-%{apiname}_api.pom
install -p -m 644 %{SOURCE3} %{buildroot}%{_datadir}/maven2/poms/JPP-%{apiname}-api.pom
%endif

%if %without mead
popd
%endif

# depmaps
%add_to_maven_depmap org.jboss.spec.%{apigroupid} jboss-%{apiname}-api_%{apiversion}_spec %{namedversion} JPP jboss-%{apiname}-api_%{apiversion}_spec
%add_to_maven_depmap %{apigroupid} %{apiartifactid} %{apiversion} JPP %{apiname}_%{apiversionu}_api

%if %with javadoc
# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/META-INF
%endif
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

# javadoc alternatives
/bin/touch %{buildroot}%{_javadocdir}/%{apiname}_%{apiversionu}_api
/bin/touch %{buildroot}%{_javadocdir}/%{apiname}_api
%endif

%if %without mead
# manual
%{__mkdir_p} %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/* %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_docdir}/%{name}-%{namedversion}/apidocs
%{__ln_s} %{_docdir}/%{name}-%{namedversion} %{buildroot}%{_docdir}/%{name}
%{__ln_s} %{_javadocdir}/%{name} %{buildroot}%{_docdir}/%{name}-%{namedversion}/apidocs

# manual alternatives
/bin/touch %{buildroot}%{_docdir}/%{apiname}_%{apiversionu}_api
/bin/touch %{buildroot}%{_docdir}/%{apiname}_api
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%{_sbindir}/update-alternatives --install %{_javadir}/%{apiname}_api.jar %{apiname}_api %{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_javadir}/%{apiname}_%{apiversionu}_api.jar %{apiname}_%{apiversionu}_api %{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_datadir}/maven2/poms/JPP-%{apiname}_api.pom %{apiname}_api_pom %{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_datadir}/maven2/poms/JPP-%{apiname}_%{apiversionu}_api.pom %{apiname}_%{apiversionu}_api_pom %{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom %{alternativespriority}
%update_maven_depmap

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove %{apiname}_api %{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar
    %{_sbindir}/update-alternatives --remove %{apiname}_%{apiversionu}_api %{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar
    %{_sbindir}/update-alternatives --remove %{apiname}_api_pom %{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom
    %{_sbindir}/update-alternatives --remove %{apiname}_%{apiversionu}_api_pom %{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom
fi

%postun
%update_maven_depmap

%if %with javadoc
%post javadoc
%{_sbindir}/update-alternatives --install %{_javadocdir}/%{apiname}_api %{apiname}_api_javadoc %{_javadocdir}/%{name} %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_javadocdir}/%{apiname}_%{apiversionu}_api %{apiname}_%{apiversionu}_api_javadoc %{_javadocdir}/%{name} %{alternativespriority}

%preun javadoc
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove %{apiname}_api_javadoc %{_javadocdir}/%{name}
    %{_sbindir}/update-alternatives --remove %{apiname}_%{apiversionu}_api_javadoc %{_javadocdir}/%{name}
fi
%endif

%if %without mead
%post manual
%{_sbindir}/update-alternatives --install %{_docdir}/%{apiname}_api %{apiname}_api_manual %{_docdir}/%{name} %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_docdir}/%{apiname}_%{apiversionu}_api %{apiname}_%{apiversionu}_api_manual %{_docdir}/%{name} %{alternativespriority}

%preun manual
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove %{apiname}_api_manual %{_docdir}/%{name}
    %{_sbindir}/update-alternatives --remove %{apiname}_%{apiversionu}_api_manual %{_docdir}/%{name}
fi
%endif

%files
%defattr(0644,root,root,0755)
%{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.jar
%{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar
%if 0
%{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-javadoc.jar
%{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec-javadoc.jar
%endif
%{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-sources.jar
%{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec-sources.jar
%ghost %{_javadir}/%{apiname}_%{apiversionu}_api.jar
%ghost %{_javadir}/%{apiname}_api.jar
%{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom
%if %without mead
%ghost %{_datadir}/maven2/poms/JPP-%{apiname}_%{apiversionu}_api.pom
%ghost %{_datadir}/maven2/poms/JPP-%{apiname}_api.pom
%{_datadir}/maven2/poms/JPP-%{apiname}-api.pom
%endif
%{_mavendepmapfragdir}/%{name}

%if %with javadoc
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%ghost %{_javadocdir}/%{apiname}_api
%ghost %{_javadocdir}/%{apiname}_%{apiversionu}_api
%endif

%if %without mead
%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{namedversion}
%doc %{_docdir}/%{name}
%doc %ghost %{_docdir}/%{apiname}_%{apiversionu}_api
%doc %ghost %{_docdir}/%{apiname}_api
%endif

%if %without mead
%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif
%endif

%changelog
* Mon Jul 21 2014 Fernando Nasser <fnasser@redhat.com> - 1.0.1-9.Final_redhat_2.2
- Remove javadoc subpackage

* Mon Jul 21 2014 Fernando Nasser <fnasser@redhat.com> - 1.0.1-8.Final_redhat_2.2
- Removed dependency on specs parent to avoid conflict on RHEL-7

* Tue Apr 02 2013 David Walluck <dwalluck@redhat.com> 0:1.0.1-7
- fix org.jboss.spec groupId

* Thu Mar 28 2013 David Walluck <dwalluck@redhat.com> 0:1.0.1-6
- api name is jsr311 not jaxrs

* Thu Mar 28 2013 David Walluck <dwalluck@redhat.com> 0:1.0.1-5
- groupId is javax.ws.rs not javax.xml
- fix broken maven support
- fix bad zip file names
- remove bad repodir code
- fix Summary and description
- don't own %%_javadir

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-4.Final_redhat_2
- Rebuild for MD5

* Mon Aug 20 2012 Vladimir Dosoudil <dosoudil@redhat.com> - 0:1.0.1-3.Final_redhat_2
- Update poms for eap 6.0.1

* Fri Aug 10 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-2.Final_redhat_2.2
- Rebuild unsigned

* Thu Jul 12 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-2.Final_redhat_1.1
- Rebuild using cache signing

* Thu May 31 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1-2.Final_redhat_1
- Remove javadocs from main package

* Wed May 02 2012 Vladimir Dosoudil <dosoudil@redhat.com> - 0:1.0.1-1.Final_redhat_1
- Upgrade to 1.0.1.Final

* Tue Mar 20 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-4.Final_redhat_1.2
- Fix jars' installation path

* Tue Mar 13 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.0-4.Final_redhat_1.1
- Populate java-signed

* Tue Feb 07 2012 Red Hat Release Engineering <release-engineering@redhat.com> - 0:1.0.0-3_redhat_1
- Rebuild to use new signing key

* Thu Feb 02 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-2
- Build RPM wrapper

* Thu May 26 2011 Fernando Nasser <fnasser@redhat.com> 0:1.0.0-1
- Adapted from jboss-jaxrpc_1.1_spec
